GestorDeProyectos/urls.py
from django.conf.urls import url
from django.contrib import admin
from django.urls import path, include
from oauth_app.views import inicio
from django.contrib.auth.views import LogoutView

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', inicio, name='inicio'),
    path('accounts/', include('allauth.urls')),
    path('logout', LogoutView.as_view()),
    path('permisos/', include('oauth_app.urls')),
    path('proyectos/', include('Proyecto.urls')),

    #path denis, esta en mayuscula la P
    #path('Proyecto/', include('Proyecto.urls')),
]

Proyecto/urls.py
from django.urls import path
from .views import *
from Proyecto import views

app_name = 'Proyecto'
urlpatterns = [
    path('', views.index, name='index'),
    path('crear/', views.formCrearProyecto, name='crearProyecto'),
    path('crearRol/<int:id>', views.formCrearRolProyecto, name='crearRolProyecto'),
    path('editarRol/<int:id>', views.formEditarRolProyecto, name='editarRolProyecto'),
    path('verRol/<int:id>', views.formVerRolProyecto, name='verRolProyecto'),
    path('importar/<int:id>', views.listarProyectosRol, name='listarProyectosRol'),
    path('importar/<int:id>/<int:id_proyecto>', views.importarRolesProyectos, name='importarRolesProyectos'),
    path('editar/<int:id>', views.editProyecto, name='editarProyecto'),
    path('eliminar/<int:id>', views.deleteProyecto, name='eliminarProyecto'),
    path('guardarUs/<int:id>', FormularioNewUs, name="guardarUs"),
    path('usuarios/<int:id>', views.listaDeUsuarios, name="listaDeUsuarios"),

    # paths para cambiar el diseño de las pestañas para la vista de un proyecto
    path('ver/UsProyecto/<int:id>', views.UsProyecto, name="UsProyecto"),
    path('ver/DetallesProyecto/<int:id>', views.DetallesProyecto, name="DetallesProyecto"),
    path('ver/MiembrosProyecto/<int:id>', views.MiembrosProyecto, name="MiembrosProyecto"),
    path('ver/RolesProyecto/<int:id>', views.RolesProyecto, name="RolesProyecto"),
    # muestra el productBacklog de un proyecto
    path('ver/SprintProyecto/ListarUsSprintBacklog/<int:id>/<int:idSprint>', views.ListarUsSprintBacklog,
         name="ListarUsSprintBacklog"),
    # Agrega US como Sprint Planning
    path('ver/SprintProyecto/agregarSprintBacklog/<int:id>/<int:idSprint>/<int:idUs>', views.agregarSprintBacklog,
         name="agregarSprintBacklog"),
    # Para creacion de un nuevo sprint
    path('ver/SprintProyecto/Crear/<int:id>', views.CrearSprint, name="CrearSprint"),
    # listar sprint
    path('ver/SprintProyecto/<int:id>', views.ListarSprint, name="ListarSprint"),
    # ruta para verificar las cosas, previo a comenzar el sprint
    path('ver/SprintProyecto/VerificarSprint/<int:id>/<int:idSprint>', views.VerificarSprint, name="VerificarSprint"),

    # Url para agregar miembro a un proyecto (muestra solo los miembros que aun no estan en el proyecto)
    path('agregarMiembro/<int:id>/<int:socialUserId>', views.formCrearMiembro, name="agregarMiembros"),
    # Se muestran los datos del miembro del proyecto (rol y disponibilidad horaria)
    path('verMiembro/<int:id>/<int:miembroId>/<int:userAccId>', views.formVerMiembro, name="verMiembros"),
    # Se muestran los campos editables de un miembro en un proyecto (rol y disponibilidad horaria)
    path('editarMiembro/<int:id>/<int:miembroId>/<int:userAccId>', views.formEditarMiembro, name="editarMiembros"),
    # Boton para eliminar un miembro de un proyecto (rol y disponibilidad horaria)
    path('eliminarMiembro/<int:idProyecto>/<int:miembroId>', views.eliminarMiembroProyecto, name="eliminarMiembros"),

    # Boton para reemplazar un miembro de un proyecto
    path('reemplazarMiembro/<int:idProyecto>/<int:miembroViejoId>/<int:idPP>', views.reemplazarMiembroProyecto,
         name="reemplazarMiembro"),

    # Boton para reemplazar un miembro de un proyecto sin eliminarlo, solo reemplazarlo en una US
    path('reemplazarMiembroEnUS/<int:idProyecto>/<int:idUS>', views.reemplazarMiembroEnUSProyecto,
         name="reemplazarMiembroEnUS"),

    # Se reemplaza al US
    path('cambioDeMiembroAlReemplazarEnUs/<int:idProyecto>/<int:userNuevoId>/<int:idPP>',
         views.cambioDeMiembroAlReemplazarEnUs, name="cambioDeMiembroAlReemplazarEnUs"),

    # Al mostrarse las historias de usuario, se deben reemplazar por otro usuario activo del proyecto, esto posibles ususarios son mostrados con esta url
    path('cambioDeMiembroAlEliminar/<int:idProyecto>/<int:miembroViejoId>/<int:userNuevoId>/<int:idPP>',
         views.cambioDeMiembroAlEliminar, name="cambioDeMiembroAlEliminar"),

    # La ruta 'detalles' en donde mostraremos una página con los detalles de un us o registro
    # aqui se pasan por url el parametro que es el id que se requiere para recuperar un reigstro
    path('ver/detalle/<int:id>', UsDetalle.mostrarDetalle, name='detalle'),

    # La ruta 'actualizar' en donde mostraremos un formulario para actualizar un  registro de la Base de Datos
    # aqui se pasan por url el parametro que es el id que se requiere para recuperar un registro
    path('ver/actualizar/<int:id>', UsActualizar.editar, name='actualizar'),

    # para listar el SPrintBacklog de un sprint en planificacion
    path('ver/SprintProyecto/SprintBacklog/<int:id>/<int:idSprint>', views.ListarSprintBacklog,
         name="ListarSprintBacklog"),

    # para editar una planning poker
    path('ver/SprintProyecto/SprintBacklog/EditarPP/<int:id>/<int:idSprint>/<int:idPP>/<int:idUs>', views.EditarPP,
         name="EditarPlanningPoker"),

    # para quitar un US de un sprintbacklog
    path('ver/SprintProyecto/SprintBacklog/<int:id>/<int:idSprint>/<int:idPP>/<int:idUs>', views.QuitarSprintBacklog,
         name="QuitarSprintBacklog"),

    path('kanban/<int:id>/<int:volver>', views.indexKanban, name="verKanban"),

    # path de PRUEBA
    path('miembroprueba/<int:id>', views.obtenerMiembro),

    # path cuando se desea agregar actividad
    path('kanban/agregarActividad/<int:id>/<int:idSprint>/<int:idUs>/<int:volver>', views.agregarActividad,
         name='agregarActividad'),

    # path para cuando se desea ver el historial de modificaciones
    path('kanban/historialMod/<int:idUs>', views.historialMod, name='historialMod'),

    # path para cuando se desea ver el historial
    path('kanban/historialUs/<int:id>/<int:idUs>/<int:volver>/<int:kanbanvolver>/<int:idSprint>', views.historialUs,
         name='historialUs'),

    # Retorna un json con los datos necesarios para el chart
    path('burndownchartjson/<int:idSprint>', views.burndownChart, name='burndownChartjson'),

    # Despliega el burndown del sprint correspondiente
    path('burndownchart/<int:idSprint>', views.burndownChartIndex, name='burndownChart'),

    # Confirmacion de Finalizar un proyecto
    path('ver/confirmarFinalizarProyecto/<int:id>', views.confirmarFinalizarProyecto,
         name='confirmarFinalizarProyecto'),

    # Finalizar un proyecto, por el ID
    path('ver/finalizarProyecto/<int:id>', views.finalizarProyecto, name='finalizarProyecto'),

    # path para desplegar el resumen cuando se termina un sprint
    path('ver/resumenFinSprint/<int:id>/<int:idSprint>', views.resumenFinSprint, name='resumenFinSprint'),

    # path para terminar el sprint y hacer algunos ajustes en los datos
    path('ver/resumen/<int:id>/<int:idSprint>', views.resumenFinSprint, name='resumenFinSprint'),
    path('SprintProyecto/<int:id>/<int:idSprint>', views.finSprint, name='finSprint'),

    # path para editar una actividad
    path(
        'kanban/historialUs/editar/<int:id>/<int:idSprint>/<int:idUs>/<int:volver>/<int:idActividad>/<int:volverkanban>',
        views.editarActividadUs, name='editarActividadUs'),

    # path para los pdf
    # para listar el Sprint Backlog de un sprint en planificacion
    path('listUserStoryPdf/<int:idSprint>/', views.listUserStoryPdf, name="listUserStoryPdf"),

    # para listar el Product Backlog de un proyecto
    path('listProductBacklogPdf/<int:idProyecto>/', views.listProductBacklogPdf, name="listProductBacklogPdf"),

    # para listar los US del sprint actual de un proyecto
    path('listUsSprintActualPdf/<int:idProyecto>/', views.listUsSprintActualPdf, name="listUsSprintActualPdf"),

    # para ver los miembros de un sprint
    path('miembroSprint/<int:idSprint>/', views.miembroEnSprint, name="miembrosSprint"),

]

oauth_app/urls.py
from django.urls import path

from oauth_app import views

app_name = 'oauth_app'
urlpatterns = [
    path('', views.index, name='index'),
    path('rol/listar/', views.listaRol, name='listarRol'),
    path('rol/crear/', views.crearRol, name='crearRol'),
    path('rol/crear/guardar', views.guardarNuevoRol, name='guardarRol'),
    path('rol/modificar/<int:RolId>/', views.modificarRol, name='modificarRol'),
    path('rol/modificar/<int:RolId>/guardar/', views.guardarModificacionRol, name='guardarModificacionRol'),
    path('rol/modificar/<int:RolId>/eliminar/', views.eliminarRol, name='eliminarRol'),
    path('<int:UsuarioId>/', views.datosUsuario, name='datosUsuario'),
    path('<int:UsuarioId>/save/', views.datosForm, name='guardar')
]

templates/oauth_app/crearRol.html
{% extends 'base.html' %}

{% block autenticacion-permiso %}
    {% if not perms.auth.change_permission or not perms.auth.add_group %}
        <meta http-equiv="REFRESH" content="0;url=/">
    {% endif %}
{% endblock %}

{% block nav-permisos %}
    <li class="nav-item active">
        <a class="nav-link" href="{% url 'oauth_app:index' %}">Permisos <span class="sr-only">(current)</span></a>
    </li>
{% endblock %}

{% block content %}
    <div class="container">
        <div class="py-5 text-center">
            <h1 class="text-light"> Crear Rol </h1>
        </div>

        <div class="bg-light rounded border-dark p-3">
            <form action="{% url 'oauth_app:guardarRol' %}" method="GET">
                <div class="form-group row m-3">
                    <label for="inputPassword" class="col-sm-2 col-form-label">Nombre:</label>
                    <div class="col-sm-10">
                        <input type="text" class="form-control" id="inputPassword" placeholder="Nombre del rol" name="nombre">
                         <small id="ayudaRol" class="form-text text-muted">Intenta poner un nomrbre descriptivo al rol</small>
                    </div>
                </div>
                <div class="text-center ml-3">
                    <h4 class="text-dark"> Permisos</h4>
                </div>
                <div class="form-check ml-3 mt-3">
                    <input class="form-check-input" type="checkbox" id="Permiso1" name="p1">
                    <label class="form-check-label" for="Permiso1">Gestionar Permisos</label>
                </div>
                <div class="form-check ml-3 mt-3">
                    <input class="form-check-input" type="checkbox" id="Permiso2" name="p2">
                    <label class="form-check-label" for="Permiso2">Crear Proyectos</label>
                </div>
                <div class="form-check ml-3 mt-3">
                    <input class="form-check-input" type="checkbox" id="Permiso3" name="p3">
                    <label class="form-check-label" for="Permiso3">Ver Todos los Proyectos</label>
                </div>
                <div class="form-check ml-3 mt-3">
                    <input class="form-check-input" type="checkbox" id="Permiso4" name="p4">
                    <label class="form-check-label" for="Permiso3">Crear Roles de Sistema</label>
                </div>
                <div class="form-check ml-3 mt-3">
                    <input class="form-check-input" type="checkbox" id="Permiso5" name="p5">
                    <label class="form-check-label" for="Permiso3">Modificar Roles de sistema</label>
                </div>
                <button type="submit" class="btn btn-primary ml-3 mt-3 ">Guardar</button>
                <a class="btn btn-secondary mt-3" href="{% url 'oauth_app:index' %}">Cancelar</a></a>
            </form>
        </div>
    </div>
{% endblock %}

templates/oauth_app/editarRol.html
{% extends 'base.html' %}

{% block autenticacion-permiso %}
    {% if not perms.auth.change_permission %}
        <meta http-equiv="REFRESH" content="0;url=/">
    {% endif %}
{% endblock %}

{% block nav-permisos %}
    <li class="nav-item active">
        <a class="nav-link" href="{% url 'oauth_app:index' %}">Permisos <span class="sr-only">(current)</span></a>
    </li>
{% endblock %}

{% block content %}
    <div class="container">
        <div class="py-5 text-center">
            <h1 class="text-light"> Crear Rol </h1>
        </div>
        <div class="bg-light rounded border-dark p-3">
            <form action="{% url 'oauth_app:guardarModificacionRol' Rolid %}" method="GET">
                <div class="form-group row m-3">
                    <label for="inputPassword" class="col-sm-2 col-form-label" disabled="true">Nombre:</label>
                    <div class="col-sm-10">
                        <input type="text" class="form-control" id="inputPassword" placeholder="Nombre del rol"
                               name="nombre" value="{% if Rol %}{{ Rol }}{% endif %}" disabled="true">
                        <small id="ayudaRol" class="form-text text-muted">No se puede modificar el nombre</small>
                    </div>
                </div>
                <div class="text-center ml-3">
                    <h4 class="text-dark"> Permisos</h4>
                </div>
                <div class="form-check ml-3 mt-3">
                    <input class="form-check-input" type="checkbox" id="Permiso1" name="p1"
                           {% if Permisos %}{% if 'change_permission' in Permisos %}checked
                           {% endif %}{% endif %}>
                    <label class="form-check-label" for="Permiso1">Gestionar Permisos</label>
                </div>
                <div class="form-check ml-3 mt-3">
                    <input class="form-check-input" type="checkbox" id="Permiso2" name="p2"
                           {% if Permisos %}{% if 'add_proyectos' in Permisos %}checked
                           {% endif %}{% endif %}>
                    <label class="form-check-label" for="Permiso2">Crear Proyectos</label>
                </div>
                <div class="form-check ml-3 mt-3">
                    <input class="form-check-input" type="checkbox" id="Permiso3" name="p3"
                           {% if Permisos %}{% if 'view_proyectos' in Permisos %}checked
                           {% endif %}{% endif %}>
                    <label class="form-check-label" for="Permiso3">Ver Todos los Proyectos</label>
                </div>
                <div class="form-check ml-3 mt-3">
                    <input class="form-check-input" type="checkbox" id="Permiso4" name="p4"
                           {% if Permisos %}{% if 'add_group' in Permisos %}checked
                           {% endif %}{% endif %}>
                    <label class="form-check-label" for="Permiso4">Crear Roles de Sistema</label>
                </div>
                <div class="form-check ml-3 mt-3">
                    <input class="form-check-input" type="checkbox" id="Permiso5" name="p5"
                           {% if Permisos %}{% if 'change_group' in Permisos %}checked
                           {% endif %}{% endif %}>
                    <label class="form-check-label" for="Permiso5">Modificar Roles de sistema</label>
                </div>
                {% if perms.auth.change_group %}
                    <button type="submit" class="btn btn-primary ml-3 mt-3 ">Guardar</button>
                    <a class="btn btn-danger mt-3" data-toggle="modal" data-target="#confirmarEliminar">Eliminar</a>
                {% endif %}
                <a class="btn btn-secondary mt-3" href="{% url 'oauth_app:listarRol' %}">
                    {% if perms.auth.change_group %}Cancelar {% else %} Atras {% endif %}</a>

                <!-- Confirmar accion de eliminar -->
                <div class="modal fade" id="confirmarEliminar" tabindex="-1" role="dialog"
                     aria-labelledby="myModalLabel">
                    <div class="modal-dialog" role="document">
                        <div class="modal-content">
                            <div class="modal-header">
                                <h5 class="modal-title">Atención!</h5>
                                <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span
                                        aria-hidden="true">&times;</span></button>
                            </div>
                            <div class="modal-body">
                                Esta seguro de que desea eliminar el rol {{ Rol }}
                            </div>
                            <div class="modal-footer">
                                <button type="button" class="btn btn-default"
                                        data-dismiss="modal">Close
                                </button>
                                <a class="btn btn-primary" href="{% url 'oauth_app:eliminarRol' Rolid %}">
                                    Confirmar
                                </a>
                            </div>
                        </div>
                    </div>
                </div>
            </form>
        </div>
    </div>
{% endblock %}

templates/oauth_app/form.html
{% extends 'base.html' %}class ProyectosForm(ModelForm):
    class Meta:
        model = Proyectos
        fields = '__all__'
        widgets = {

        }


{% block autenticacion-permiso %}
    {% if not perms.auth.change_permission %}
        <meta http-equiv="REFRESH" content="0;url=/">
    {% endif %}
{% endblock %}

{% block nav-permisos %}
    <li class="nav-item active">
        <a class="nav-link" href="{% url 'oauth_app:index' %}">Permisos <span class="sr-only">(current)</span> </a>
    </li>
{% endblock %}

{% block content %}
<div class="container">
    <div class="py-5 text-center">
        <h1 class="text-light"> Gestionar permisos </h1>
    </div>

    <div class="bg-light rounded border-dark">
        <div class="d-flex align-items-center p-3 my-3 text-dark-50">
            <img class="mr-3" src="{{ Usuario.extra_data.picture }}" width="48" height="48">
            <div>
                <h6 class="mb-0 lh-100">{{ Usuario.extra_data.given_name }} {{ Usuario.extra_data.family_name }} </h6>
                <small>{{ Usuario.extra_data.email }}</small>
            </div>
        </div>

        <div class="text-center ml-3">
            <h4 class="text-dark"> Permisos</h4>
        </div>

        <div class="bg-light">
            <form action="{% url 'oauth_app:guardar' Usuario.id %}" method="GET">
                <select class="custom-select custom-select mb-3" {% for r in Rol %}{% if 'SUPERADMIN' == r.name %}disabled{% endif %}{% endfor %}  name="seleccionRol">
                    <option>Selecciona un rol</option>
                    {% for r in Roles %}
                        {% if not 'SUPERADMIN' == r.name %}
                            <option value="{{ r.id }}" {% if r.id == Rol.0.id %}selected{% endif %}>{{ r.name }}</option>
                        {% endif %}
                    {% endfor %}
                </select>
                <!--
                    <div class="form-check ml-3 mt-3">
                        <input class="form-check-input" type="checkbox" id="Permiso1" name="p1"
                               {% if Permisos %}{% if 'auth.change_permission' in Permisos %}checked
                               {% endif %}{% endif %}>
                        <label class="form-check-label" for="Permiso1">Gestionar Permisos</label>
                    </div>
                    <div class="form-check ml-3 mt-3">
                        <input class="form-check-input" type="checkbox" id="Permiso2" name="p2"
                               {% if Permisos %}{% if 'Proyecto.add_proyecto' in Permisos %}checked
                               {% endif %}{% endif %}>
                        <label class="form-check-label" for="Permiso2">Crear Proyectos</label>
                    </div>
                    <div class="form-check ml-3 mt-3">
                        <input class="form-check-input" type="checkbox" id="Permiso3" name="p3"
                               {% if Permisos %}{% if 'Proyecto.view_proyecto' in Permisos %}checked
                               {% endif %}{% endif %}>
                        <label class="form-check-label" for="Permiso3">Ver Todos los Proyectos</label>
                    </div>
                    -->
                <button type="submit" class="btn btn-primary ml-3 mt-3 mb-3" {% for r in Rol %}{% if 'SUPERADMIN' == r.name %}disabled{% endif %}{% endfor %} >Guardar</button>
                <a class="btn btn-secondary mt-3 mb-3" href="{% url 'oauth_app:index' %}">Cancelar</a></a>
            </form>
        </div>
    </div>
</div>
{% endblock %}

templates/oauth_app/index.html
{% extends 'base.html' %}


{% block autenticacion-permiso %}
    {% if not perms.auth.change_permission %}
        <meta http-equiv="REFRESH" content="0;url=/">
    {% endif %}
{% endblock %}

{% block nav-permisos %}
    <li class="nav-item active">
        <a class="nav-link" href="#">Permisos <span class="sr-only">(current)</span> </a>
    </li>
{% endblock %}

{% block content %}
    <div class="container mb-5">
        <div class="py-5 text-center">
            <h1 class="text-light"> Lista de usuarios </h1>
        </div>
        <div class="row bg-light border rounded border-dark mb-3">

            <div class="input-group">
                <input type="text" id="buscarUsuario" onkeyup="buscarTabla('buscarUsuario','tablaUsuario')" placeholder="Buscar por nombre"
                       title="Type in a name" class="form-control m-3" aria-describedby="inputGroup-sizing-lg">

                <div class="input-group-append">
                    <button class="btn btn-outline-secondary dropdown-toggle m-3" type="button" data-toggle="dropdown"
                            aria-haspopup="true" aria-expanded="false">Roles del sistema
                    </button>
                    <div class="dropdown-menu">
                        {% if perms.auth.add_group %}
                            <a class="dropdown-item" href="{% url 'oauth_app:crearRol' %}">Crear Roles</a>
                        {% endif %}
                        <a class="dropdown-item" href="{% url 'oauth_app:listarRol' %}">Ver Roles</a>
                    </div>
                </div>

            </div>

            <table class="table table-hover" id="tablaUsuario">
                <thead class="thead-dark">
                <tr>
                    <th scope="col" onclick="sortTable(0,'tablaUsuario','Numero')">#</th>
                    <th scope="col" onclick="sortTable(1,'tablaUsuario','String')">Nombre</th>
                    <th scope="col" onclick="sortTable(2,'tablaUsuario','String')">Apellido</th>
                    <th scope="col" onclick="sortTable(3,'tablaUsuario','String')">Correo electronico</th>
                    <th scope="col">Acción</th>
                </tr>
                </thead>
                <tbody>
                {% if listaDeUsarios %}
                    {% for u in listaDeUsarios %}
                        <tr>
                            <td class="font-weight-bold" scope="row">{{ u.id }}</td>
                            <td>{{ u.extra_data.given_name }}</td>
                            <td>{{ u.extra_data.family_name }}</td>
                            <td style="word-wrap: break-word;min-width: 160px;max-width: 160px;">{{ u.extra_data.email }}</td>
                            <td><a href="{% url 'oauth_app:datosUsuario' u.id %}"
                                   class="btn {% if  user.email  ==  u.extra_data.email %}disabled{% else %}text-primary{% endif %}">Ver
                                permisos</a></td>
                        </tr>
                    {% endfor %}
                {% else %}

                {% endif %}
                </tbody>

            </table>
        </div>
    </div>
{% endblock %}

templates/oauth_app/listarRol.html
{% extends 'base.html' %}

{% block autenticacion-permiso %}
    {% if not perms.auth.change_permission %}
        <meta http-equiv="REFRESH" content="0;url=/">
    {% endif %}
{% endblock %}

{% block nav-permisos %}
    <li class="nav-item active">
        <a class="nav-link" href="{% url 'oauth_app:index' %}">Permisos <span class="sr-only">(current)</span></a>
    </li>
{% endblock %}

{% block content %}
    <div class="container">
        <div class="py-5 text-center">
            <h1 class="text-light"> Lista de usuarios </h1>
        </div>
        <div class="row bg-light border rounded border-dark">

            <div class="input-group">
                <input type="text" id="buscarUsuario" onkeyup="buscarTabla('buscarUsuario','tablaUsuarioRol')" placeholder="Buscar por nombre"
                       title="Type in a name" class="form-control m-3" aria-describedby="inputGroup-sizing-lg">
                <div class="input-group-append">
                    <a class="btn btn-outline-secondary m-3" type="button"
                            href="{% url 'oauth_app:index' %}">Volver
                    </a>
                </div>
            </div>


            <table class="table table-hover" id="tablaUsuarioRol">
                <thead class="thead-dark">
                <tr>
                    <th scope="col" onclick="sortTable(0,'tablaUsuarioRol','Numero')">#</th>
                    <th scope="col" onclick="sortTable(1,'tablaUsuarioRol','String')">Nombre</th>
                    <th scope="col">Acción</th>
                </tr>
                </thead>
                <tbody>
                {% if listaRol %}
                    {% for u in listaRol %}
                        {% if not u.name == 'SUPERADMIN'  %}
                            <tr>
                                <td class="font-weight-bold" scope="row">{{ u.id }}</td>
                                <td style="word-wrap: break-word;min-width: 160px;max-width: 160px;">{{ u.name }}</td>
                                <td><a class="btn {% if u.name == 'Administrador' or u.name == 'Nuevo Usuario' %}disabled{% else %}text-primary{% endif %}" href="{% url 'oauth_app:modificarRol' u.id %}" >Editar</a></td>
                            </tr>
                        {% endif %}
                    {% endfor %}
                {% else %}

                {% endif %}
                </tbody>

            </table>
        </div>
    </div>
    <script>
        function buscarTabla() {
            var input, filter, table, tr, td, i, txtValue;
            input = document.getElementById("buscarUsuario");
            filter = input.value.toUpperCase();
            table = document.getElementById("tablaUsuario");
            tr = table.getElementsByTagName("tr");
            for (i = 0; i < tr.length; i++) {
                td = tr[i].getElementsByTagName("td")[0];
                if (td) {
                    txtValue = td.textContent || td.innerText;
                    if (txtValue.toUpperCase().indexOf(filter) > -1) {
                        tr[i].style.display = "";
                    } else {
                        tr[i].style.display = "none";
                    }
                }
            }
        }
    </script>
{% endblock %}